<?php

#
# ss.php					Author: Rich West
#						Rich.West@wesmo.com
#
# This is a not-all-that-complicated-but-not-all-that-simple perl script
# which takes the information from the database, jumbles it all up, and
# adds new entries to the database.  Basically, it does all of the picking
# of who-gets-who, while keeping in mind that there can be several different
# "groupings" of people (aka: multiple non-related secret santa picks could
# be handled by this same server) as well as certain restrictions on picks
# (people probably shouldn't (1) pick their spouse, (2) pick the same person
# they had last year, etc).
#
################################################################################

################################################################################
#
# Pull all of the names out of the database.
#
################################################################################
function get_people($gid)
{
   global $connect;

   $i = 0;
   $query = "SELECT uid FROM accounts WHERE gid='$gid' AND optout='0'";
   $result = mysql_query($query,$connect);
   while ($row = mysql_fetch_row($result))
   {
      $people[$i] = $row[0];
      $i++;
   }
   return($people);
}

################################################################################
#
# Pull all of the matches from the database that are considered "invalid".
#
################################################################################
function get_bad_matches($gid)
{
   global $connect;

   $i=0;
   $query = "SELECT uid1,uid2 FROM invalids WHERE gid='$gid'";
   $result = mysql_query($query,$connect);
   while ($row = mysql_fetch_row($result))
   {
      $INVALIDS[$i][0] = $row[0];
      $INVALIDS[$i][1] = $row[1];
      $i++;
   }
   if ($_POST['remember'])
   {
      $query = "SELECT name1,name2 FROM picks where id='$gid' AND expire < '" . date("Y") . "-12-01' AND expire > '" . (date("Y")-1) . "-12-01'";
      $result = mysql_query($query,$connect);
      while ($row = mysql_fetch_row($result))
      {
         $INVALIDS[$i][0] = $row[0];
         $INVALIDS[$i][1] = $row[1];
         $i++;
      }
   }
   return ($INVALIDS);
}

################################################################################
#
# Randomly pick a person.
#
################################################################################
function get_randomness($PEOPLE)
{
   $random_choice = rand(0,sizeof($PEOPLE)-1);
   return ($random_choice);
}

################################################################################
#
# Eliminate all of the bad matches.
#
################################################################################
function get_available($current_id,$PEOPLE,$invalids)
{
   for ($j=0; $j<=sizeof($invalids)-1; $j++)
   {
      if ($invalids[$j][0] == $current_id)
      {
#         $PEOPLE = array_minus_array(array_diff($PEOPLE, array($invalids[$j][1])));
         $PEOPLE = array_diff($PEOPLE, array($invalids[$j][1]));
      }
      if ($invalids[$j][1] == $current_id)
      {
#         $PEOPLE = array_minus_array(array_diff($PEOPLE, array($invalids[$j][0])));
         $PEOPLE = array_diff($PEOPLE, array($invalids[$j][0]));
      }
   }
   return ($PEOPLE);
}

################################################################################
#
# Clears out all of the old "picks"
#
################################################################################
function clear_picks($gid)
{
   global $connect;

   $query = "DELETE FROM picks WHERE id='$gid' AND expire > '" . date("Y") . "-12-01'";
   $result = mysql_query($query,$connect);
}

################################################################################
#
# Get the next valid pick for the person supplied from the ones left over.
#
################################################################################
function get_pick($i,$PEOPLE)
{
   $randomness = get_randomness($PEOPLE);
   $try=1;
   while ( ($PEOPLE[$randomness] == $i) and ($try <= 50))
   {
      $try++;
      $randomness = get_randomness($PEOPLE);
   }
   if ($try > 5)
   {
      return (0);
   }
   return ($PEOPLE[$randomness]);
}


################################################################################
#
# A simple function to subtract the contents of one array from another
# and the result being an array populated with the unique values with
# no empty entries.
#
################################################################################
function array_minus_array($a,$b)
{
   if (!$a)
   {
      return $a;
   }
   if (!$b)
   {
      return $b;
   }
   $c = Array();
   foreach ($a as $key => $val)
   {  
      $posb = array_search($val,$b);
      if (is_integer($posb))
      {
         unset($b[$posb]);  
      }
      else
      {
         $c[] = $val;
      }
   }
   return $c;
}

################################################################################
#
# Save the picks to the database.
#
################################################################################
function save_picks($gid,$total_people,$pick)
{
   global $connect;

   $expire_date = date("Y");
   $expire_date++;
   $expire_date = "$expire_date-11-01";
   for ($i=0; $i<=$total_people-1; $i++)
   {
      $query = "INSERT INTO picks VALUES ('$gid', '" . $pick[$i][0] . "', '" . $pick[$i][1] . "', '$expire_date')";
      $result = mysql_query($query,$connect);
   }
}

################################################################################
#
# The main brains of the program.
#
################################################################################
function shuffle_names($gid)
{
   clear_picks($gid);
   $PEOPLE = get_people($gid);
   $invalids = get_bad_matches($gid);
   $ORIG_PEOPLE = $PEOPLE;
   $not_done = 1;
   $attempt = 0;
   $failed = 0;
   while ($not_done)
   {
      for ($i=0; $i<=sizeof($ORIG_PEOPLE)-1; $i++)
      {
         $AVAIL = get_available($ORIG_PEOPLE[$i], $PEOPLE,$invalids);
         //delete $AVAIL{$temp};
         if (sizeof($AVAIL) == 0)
         {
            $attempt++;
            if ($attempt > 50)
            {
               $not_done = 0;
               $failed=1;
#               echo "Could not come up with a good selection.\n";
            }
            $PEOPLE = $ORIG_PEOPLE;
            last;
         }
         $my_pick = get_pick($ORIG_PEOPLE[$i],$AVAIL);
         if ($my_pick == 0)
         {
            $failed=1;
         }
         $PEOPLE = array_minus_array($PEOPLE, array($my_pick));
         $pick[$i][0] = $ORIG_PEOPLE[$i];
         $pick[$i][1] = $my_pick;
      }
      if (!$attempt) { $not_done = 0; }
   }
   if ($failed) { return 0; }
   save_picks($gid, sizeof($ORIG_PEOPLE),$pick);
   return 1;
}

 ?>
